## libjwt 1.9.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.9)

if (MSVC)
	set (CMAKE_SYSTEM_VERSION 8.1 CACHE TYPE INTERNAL FORCE)
endif ()

project (jwt)

list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

string(REPLACE "\\" "/" CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

option (ENABLE_DEBUG_INFO_IN_RELEASE "Enable adding debug info to release build." OFF)
option (ENABLE_LTO "Enable link time optimizations." OFF)

if (MSVC)
	option (STATIC_RUNTIME "Link runtome library statically." OFF)
endif ()

if (UNIX)
	option (BUILD_TESTS "Build test projects." OFF)
endif ()

include_directories (include)

if (MSVC)
	set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /Ox")
endif ()

if (STATIC_RUNTIME)
	set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
	set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
	set (CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} /MT")
	set (CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /MT")
endif ()

if (ENABLE_DEBUG_INFO_IN_RELEASE)
	if (MSVC)
		set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /Zi")
		set (CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
		set (CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
	else ()
		set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -g")
	endif ()
endif ()

if (ENABLE_LTO)
	if (MSVC)
		set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /GL")
		set (CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} /GL")
		set (CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /GL")

		set (CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
		set (CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL} /LTCG")
		set (CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")

		set (CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG")
		set (CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL "${CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL} /LTCG")
		set (CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")
	endif ()
endif ()

add_subdirectory (libjwt)

if (${BUILD_TESTS})
	add_subdirectory (tests)
endif ()

=== tests/CMakeLists.txt ===
find_package (Check REQUIRED)

enable_testing ()

set (TARGET_NAMES jwt_dump jwt_ec jwt_encode jwt_grant jwt_new jwt_rsa)

if (UNIX)
	set (PLATFORM_LIBRARIES pthread)
endif ()

foreach (TARGET_NAME ${TARGET_NAMES})
	add_executable (${TARGET_NAME} ${TARGET_NAME}.c)
	target_include_directories (${TARGET_NAME} PRIVATE ${CHECK_INCLUDE_DIR})
	if (UNIX AND ENABLE_LTO)
		set_property(TARGET ${TARGET_NAME} PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
	endif ()
	target_compile_definitions (${TARGET_NAME} PRIVATE KEYDIR=\"${CMAKE_CURRENT_SOURCE_DIR}/keys\")
	target_link_libraries (${TARGET_NAME} jwt ${CHECK_LIBRARIES} ${PLATFORM_LIBRARIES})
	add_test (${TARGET_NAME} ${TARGET_NAME})
endforeach ()

## libjwt 1.8.0+dfsg

=== debian/changelog ===
libjwt (1.8.0+dfsg-1) unstable; urgency=medium

  * Initial release

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 25 Jul 2017 19:32:33 +0200

=== debian/control ===
Source: libjwt
Section: devel
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 10)
	, pkg-config
	, libjansson-dev
	, libssl-dev
	, libb64-dev
	, check
#	, gnutls-dev
Standards-Version: 4.0.0
Homepage: https://github.com/benmcollins/libjwt
#Vcs-Git: https://anonscm.debian.org/collab-maint/oauth2-server.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/oauth2-server.git

Package: libjwt0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library to handle JWT (JSON Web Token)
 libjwt is a library which allows you to encode and decode 
 JSON Web Tokens (JWT).
 .
 JSON Web Tokens are an open, industry standard RFC 7519 method for 
 representing claims securely between two parties.

Package: libjwt-dev
Architecture: any
Section: libdevel
Depends: libjwt0 (= ${binary:Version})
        , ${misc:Depends}
Description: C library to handle JWT (JSON Web Token) - development
 libjwt is a library which allows you to encode and decode 
 JSON Web Tokens (JWT).
 .
 JSON Web Tokens are an open, industry standard RFC 7519 method for 
 representing claims securely between two parties.
 .
 This package contains the development files.

## libjwt 1.9.0

=== debian/changelog ===
libjwt (1.9.0-4) unstable; urgency=medium

  * debian/control: use correct salsa VCS URLs

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 14 Dec 2018 18:20:04 +0100

libjwt (1.9.0-3) unstable; urgency=medium

  * debian/copyright: upstream changed license to MPL 2.0

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 01 Dec 2018 22:20:04 +0100

libjwt (1.9.0-2) unstable; urgency=medium

  * debian/control: bump standard to 4.2.1 (no changes)
  * debian/control: add salsa VCS URLs
  * debian/*install: multiarchify files
  * debian/control: add "Multi-Arch: same" for libjwt-dev
                    (this was suggested by the Multiarch hinter)
  * add symbols file

 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 21 Nov 2018 19:20:04 +0100

libjwt (1.9.0-1) unstable; urgency=medium

  * New upstream release
  * debian/control: use dh11
  * debian/control: bump standard to 4.1.3 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 27 Jan 2018 19:31:04 +0100

libjwt (1.8.0+dfsg-2) unstable; urgency=medium

  * debian/control: bump standard to 4.1.0 (no changes)
  * debian/control: add VCS URLs
  * debian/control: set team as maintainer

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 03 Sep 2017 20:32:33 +0200

=== debian/control ===
Source: libjwt
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 11)
	, pkg-config
	, libjansson-dev
	, libssl-dev
	, libb64-dev
	, check
	, dh-exec
#	, gnutls-dev
Standards-Version: 4.2.1
Homepage: https://github.com/benmcollins/libjwt
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/libjwt
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/libjwt.git

Package: libjwt0
Section: libs
Multi-Arch: same
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library to handle JWT (JSON Web Token)
 libjwt is a library which allows you to encode and decode
 JSON Web Tokens (JWT).
 .
 JSON Web Tokens are an open, industry standard RFC 7519 method for
 representing claims securely between two parties.

Package: libjwt-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libjwt0 (= ${binary:Version})
        , ${misc:Depends}
Description: C library to handle JWT (JSON Web Token) - development
 libjwt is a library which allows you to encode and decode
 JSON Web Tokens (JWT).
 .
 JSON Web Tokens are an open, industry standard RFC 7519 method for
 representing claims securely between two parties.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with autoreconf

override_dh_auto_install:
	echo dh_auto_install

## libjwt 1.10.1

=== libjwt/CMakeLists.txt ===
set (TARGET_NAME ${CMAKE_PROJECT_NAME})

option (BUILD_SHARED_LIBS "Build libjwt as shared library instead as static one." OFF)
option (WITHOUT_OPENSSL "Use GnuTLS for encryption instead of OpenSSL" OFF)

if (UNIX)
	option (ENABLE_PIC "Use position independent code in static library build." OFF)
endif ()

if (BUILD_SHARED_LIBS)
	set (LIBRARY_TYPE SHARED)
else ()
	set (LIBRARY_TYPE STATIC)
	if (MSVC)
		set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /Z7")
		set (CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /Z7")
		if (${ENABLE_DEBUG_INFO_IN_RELEASE})
			set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /Z7")
		endif ()
	endif ()
endif ()

if (WITHOUT_OPENSSL)
	find_package (GnuTLS REQUIRED)
	set (FILES_TO_REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/jwt-openssl.c)
	set (SSL_LIBRARY_INCLUDE_DIR ${GNUTLS_INCLUDE_DIR})
	set (SSL_LIBRARIES_DEBUG ${GNUTLS_LIBRARY})
	set (SSL_LIBRARIES_OPTIMIZED ${GNUTLS_LIBRARY})
else ()
	if (MSVC AND STATIC_RUNTIME)
		set (OPENSSL_MSVC_STATIC_RT TRUE)
	endif ()
	find_package (OpenSSL REQUIRED)
	set (FILES_TO_REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/jwt-gnutls.c)
	set (SSL_LIBRARY_INCLUDE_DIR ${OPENSSL_INCLUDE_DIR})
	if (MSVC)
		set (SSL_LIBRARIES_DEBUG ${LIB_EAY_DEBUG} ${SSL_EAY_DEBUG})
		set (SSL_LIBRARIES_OPTIMIZED ${LIB_EAY_RELEASE} ${SSL_EAY_RELEASE})
	else ()
		set (SSL_LIBRARIES_DEBUG ${OPENSSL_CRYPTO_LIBRARY})
		set (SSL_LIBRARIES_OPTIMIZED ${OPENSSL_CRYPTO_LIBRARY})
	endif ()
endif ()

find_package (Jansson REQUIRED)

write_file(${CMAKE_CURRENT_BINARY_DIR}/config.h "")

file (GLOB SOURCE_FILES "../include/*.h" "*.h" "*.c")
list (REMOVE_ITEM SOURCE_FILES ${FILES_TO_REMOVE})

add_library (${TARGET_NAME} ${LIBRARY_TYPE} ${SOURCE_FILES})

target_include_directories (${TARGET_NAME} PRIVATE
	${SSL_LIBRARY_INCLUDE_DIR}
	${JANSSON_INCLUDE_DIRS}
	${CMAKE_CURRENT_BINARY_DIR}
	)

if (UNIX AND ENABLE_LTO)
	set_property(TARGET ${TARGET_NAME} PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
endif ()

if (MSVC)
	target_compile_definitions (${TARGET_NAME} PRIVATE _CRT_SECURE_NO_WARNINGS)
	if (BUILD_SHARED_LIBS)
		target_compile_definitions (${TARGET_NAME}
			PUBLIC JWT_DLL_CONFIG
			PRIVATE JWT_BUILD_SHARED_LIBRARY
			)
	endif ()
endif ()

if (NOT BUILD_SHARED_LIBS AND ENABLE_PIC)
	target_compile_options (${TARGET_NAME} PRIVATE -fPIC)
endif ()

target_link_libraries (${TARGET_NAME}
	debug ${SSL_LIBRARIES_DEBUG} optimized ${SSL_LIBRARIES_OPTIMIZED}
	${JANSSON_LIBRARIES}
	)

install (TARGETS ${TARGET_NAME}
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
	)

install (FILES
	${CMAKE_SOURCE_DIR}/include/jwt.h
	DESTINATION include/
	)

=== debian/changelog ===
libjwt (1.10.1-1) sid; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.3.0 (no changes)
  * debian/*.symbols: add "* Build-Depends-Package:"

  [Nicolas Mora]
  * debian/control: add new package libjwt-gnutls, libjwt with gnutls backend
  * debian/rules: run dh_auto_tests on build

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 13 Jan 2019 15:13:51 +0100

## libjwt 1.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.9)
+cmake_minimum_required (VERSION 3.7)
 
 if (MSVC)
 	set (CMAKE_SYSTEM_VERSION 8.1 CACHE TYPE INTERNAL FORCE)
@@ -21,6 +21,9 @@
 	option (BUILD_TESTS "Build test projects." OFF)
 endif ()
 
+if (APPLE)
+	add_definitions(-DNO_WEAK_ALIASES)
+endif ()
 include_directories (include)
 
 if (MSVC)

=== libjwt/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set (TARGET_NAME ${CMAKE_PROJECT_NAME})
+set (TARGET_NAME ${PROJECT_NAME})
 
 option (BUILD_SHARED_LIBS "Build libjwt as shared library instead as static one." OFF)
 option (WITHOUT_OPENSSL "Use GnuTLS for encryption instead of OpenSSL" OFF)
@@ -87,6 +87,6 @@
 	)
 
 install (FILES
-	${CMAKE_SOURCE_DIR}/include/jwt.h
+	${PROJECT_SOURCE_DIR}/include/jwt.h
 	DESTINATION include/
 	)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 enable_testing ()
 
-set (TARGET_NAMES jwt_dump jwt_ec jwt_encode jwt_grant jwt_new jwt_rsa)
+set (TARGET_NAMES jwt_dump jwt_ec jwt_encode jwt_grant jwt_header jwt_new jwt_rsa)
 
 if (UNIX)
 	set (PLATFORM_LIBRARIES pthread)

=== debian/changelog ===
libjwt (1.10.2-1) unstable; urgency=medium

  * New upstream release

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 14 Jul 2019 19:03:00 +0200

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,9 @@
 	, libb64-dev
 	, check
 	, dh-exec
-#	, gnutls-dev
-Standards-Version: 4.2.1
+	, gnutls-dev
+	, quilt
+Standards-Version: 4.3.0
 Homepage: https://github.com/benmcollins/libjwt
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/libjwt
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/libjwt.git
@@ -42,3 +43,36 @@
  representing claims securely between two parties.
  .
  This package contains the development files.
+
+Package: libjwt-gnutls0
+Section: libs
+Multi-Arch: same
+Architecture: any
+Conflicts: libjwt0
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: C library to handle JWT (JSON Web Token) - GnuTLS flavour
+ libjwt is a library which allows you to encode and decode
+ JSON Web Tokens (JWT). GnuTLS flavour.
+ .
+ JSON Web Tokens are an open, industry standard RFC 7519 method for
+ representing claims securely between two parties.
+ .
+ SSL support is provided by GnuTLS.
+
+Package: libjwt-gnutls-dev
+Architecture: any
+Multi-Arch: same
+Section: libdevel
+Conflicts: libjwt-dev
+Depends: libjwt-gnutls0 (= ${binary:Version})
+        , ${misc:Depends}
+Description: Development files for libjwt - GnuTLS flavour
+ libjwt is a library which allows you to encode and decode
+ JSON Web Tokens (JWT). GnuTLS flavour.
+ .
+ JSON Web Tokens are an open, industry standard RFC 7519 method for
+ representing claims securely between two parties.
+ .
+ This package contains the development files.
+ .
+ SSL support is provided by GnuTLS.

=== debian/rules ===
--- 
+++ 
@@ -16,5 +16,30 @@
 %:
 	dh $@ --with autoreconf
 
+override_dh_auto_configure:
+	# create build directory for both flavours (openssl and gnutls)
+	mkdir -p debian/build-openssl debian/build-gnutls
+	# undo last patch, which is the gnutls patch
+	quilt pop
+	tar -cf - --exclude=debian/build* --exclude=.pc . \
+	    | tar -xf - -C debian/build-openssl
+	# reapply last patch, which is the gnutls patch
+	quilt push
+	tar -cf - --exclude=debian/build* --exclude=.pc . \
+	    | tar -xf - -C debian/build-gnutls
+	# execute dh_auto_configure on both build flavours
+	cd debian/build-openssl && autoreconf -i && dh_auto_configure
+	cd debian/build-gnutls && autoreconf -i && dh_auto_configure -- --without-openssl
+
+override_dh_auto_build:
+	# execute dh_auto_build on both build flavours
+	cd debian/build-openssl && dh_auto_build
+	cd debian/build-gnutls && dh_auto_build
+
+override_dh_auto_test:
+	# execute dh_auto_test on both build flavours
+	cd debian/build-openssl && dh_auto_test
+	cd debian/build-gnutls && dh_auto_test
+
 override_dh_auto_install:
 	echo dh_auto_install

## libjwt 1.17.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,10 @@
-cmake_minimum_required (VERSION 3.7)
+cmake_minimum_required (VERSION 3.7...3.15)
+
+set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+
+if (${CMAKE_VERSION} VERSION_LESS 3.14.7 AND ${CMAKE_GENERATOR} STREQUAL "Visual Studio 16 2019")
+	message(FATAL_ERROR "Please update your version of CMake to version 3.14.7 or greater in order to use Visual Studio 2019")
+endif()
 
 if (MSVC)
 	set (CMAKE_SYSTEM_VERSION 8.1 CACHE TYPE INTERNAL FORCE)
@@ -6,12 +12,11 @@
 
 project (jwt)
 
-list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
-
 string(REPLACE "\\" "/" CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
 
 option (ENABLE_DEBUG_INFO_IN_RELEASE "Enable adding debug info to release build." OFF)
 option (ENABLE_LTO "Enable link time optimizations." OFF)
+option (BUILD_EXAMPLES "Build example projects." ON)
 
 if (MSVC)
 	option (STATIC_RUNTIME "Link runtome library statically." OFF)
@@ -65,6 +70,39 @@
 
 add_subdirectory (libjwt)
 
+if (${BUILD_EXAMPLES})
+	add_subdirectory (examples)
+endif()
+
 if (${BUILD_TESTS})
 	add_subdirectory (tests)
 endif ()
+
+
+# extract version from configure.ac
+FILE(READ "${CMAKE_CURRENT_SOURCE_DIR}/configure.ac" configure_ac_contents)
+STRING(REGEX REPLACE ";" "\\\\;" configure_ac_contents "${configure_ac_contents}")
+STRING(REGEX REPLACE "\n" ";" configure_ac_contents "${configure_ac_contents}")
+foreach(configure_ac_line ${configure_ac_contents})
+	if("${configure_ac_line}" MATCHES "^[ ]*AC_INIT")
+		string(REGEX MATCH "[0-9]+\.[0-9]+\.[0-9]+" version_string "${configure_ac_line}")
+		message(STATUS "version from configure.ac: '${version_string}'")
+		break()
+	endif()
+endforeach()
+
+set(INCLUDE_INSTALL_DIR include/)
+set(LIB_INSTALL_DIR lib/)
+set(LIBJWT_VERSION ${version_string})
+include(CMakePackageConfigHelpers)
+configure_package_config_file(cmake/libjwtConfig.cmake.in
+  ${CMAKE_CURRENT_BINARY_DIR}/libjwtConfig.cmake
+  INSTALL_DESTINATION ${LIB_INSTALL_DIR}/libjwt/cmake
+  PATH_VARS INCLUDE_INSTALL_DIR)
+write_basic_package_version_file(
+  ${CMAKE_CURRENT_BINARY_DIR}/libjwtConfigVersion.cmake
+  VERSION ${LIBJWT_VERSION}
+  COMPATIBILITY SameMajorVersion )
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libjwtConfig.cmake
+              ${CMAKE_CURRENT_BINARY_DIR}/libjwtConfigVersion.cmake
+        DESTINATION ${LIB_INSTALL_DIR}/libjwt/cmake )

=== examples/CMakeLists.txt ===
#find_package(LibJWT)

add_definitions(-D_GNU_SOURCE)

add_executable(jwtauth
	main-auth.c
)

target_compile_options(jwtauth PRIVATE -Werror -Wall -Wextra)
target_compile_options(jwtauth PRIVATE -g -fPIC -O2 -funwind-tables)

set_property(TARGET jwtauth PROPERTY C_STANDARD 11)

target_link_libraries(jwtauth ${PROJECT_NAME})
#target_link_libraries(jwtauth ${LIBJWT_LIBRARIES})

#target_include_directories(jwtauth
#	PUBLIC ${LIBJWT_INCLUDE_DIRS}}
#)

add_executable(jwtgen
	main-gen.c
)

target_compile_options(jwtgen PRIVATE -Werror -Wall -Wextra)
target_compile_options(jwtgen PRIVATE -g -fPIC -O2 -funwind-tables)

set_property(TARGET jwtgen PROPERTY C_STANDARD 11)

target_link_libraries(jwtgen ${PROJECT_NAME})
#target_link_libraries(jwtgen ${LIBJWT_LIBRARIES})

#target_include_directories(jwtgen
#	PUBLIC ${LIBJWT_INCLUDE_DIRS}
#)

=== debian/changelog ===
libjwt (1.17.0-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:08:29 +0000

libjwt (1.17.0-2build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:24:34 +0000

libjwt (1.17.0-2) unstable; urgency=medium

  * finally upload to unstable
    (fix for CVE-2024-25189 in unstable: Closes: #1063534)
    (reverse dependencies did build successful, maintainers are aware)

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 20 Feb 2024 23:21:00 +0100

libjwt (1.17.0-1) experimental; urgency=medium

  * New upstream release.
  * Contains fix for CVE-2024-25189 (Closes: #1063534)
  * update symbols file

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 18 Feb 2024 13:21:00 +0100

libjwt (1.16.0-1) experimental; urgency=medium

  * New upstream release.
  * debian/rules: do not build examples
  * debian/rules: temporarily disable tests due to: FAIL: jwt_rsa_pss
  * debian/control: use dh13
  * debian/control: bump standard to 4.6.2 (no changes)
  * debian/control: add Rules-Requires-Root: no
  * debian/control: bump soname of libjwt from 0 to 2

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 09 Sep 2023 00:35:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: libjwt
 Section: devel
 Priority: optional
-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
-Build-Depends: debhelper (>= 11)
+Build-Depends: debhelper-compat (= 13)
 	, pkg-config
 	, libjansson-dev
 	, libssl-dev
@@ -12,12 +13,13 @@
 	, dh-exec
 	, gnutls-dev
 	, quilt
-Standards-Version: 4.3.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/benmcollins/libjwt
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/libjwt
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/libjwt.git
+Rules-Requires-Root: no
 
-Package: libjwt0
+Package: libjwt2
 Section: libs
 Multi-Arch: same
 Architecture: any
@@ -33,7 +35,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libjwt0 (= ${binary:Version})
+Depends: libjwt2 (= ${binary:Version})
         , ${misc:Depends}
 Description: C library to handle JWT (JSON Web Token) - development
  libjwt is a library which allows you to encode and decode
@@ -44,11 +46,11 @@
  .
  This package contains the development files.
 
-Package: libjwt-gnutls0
+Package: libjwt-gnutls2
 Section: libs
 Multi-Arch: same
 Architecture: any
-Conflicts: libjwt0
+Conflicts: libjwt2
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C library to handle JWT (JSON Web Token) - GnuTLS flavour
  libjwt is a library which allows you to encode and decode
@@ -64,7 +66,7 @@
 Multi-Arch: same
 Section: libdevel
 Conflicts: libjwt-dev
-Depends: libjwt-gnutls0 (= ${binary:Version})
+Depends: libjwt-gnutls2 (= ${binary:Version})
         , ${misc:Depends}
 Description: Development files for libjwt - GnuTLS flavour
  libjwt is a library which allows you to encode and decode

=== debian/rules ===
--- 
+++ 
@@ -28,8 +28,8 @@
 	tar -cf - --exclude=debian/build* --exclude=.pc . \
 	    | tar -xf - -C debian/build-gnutls
 	# execute dh_auto_configure on both build flavours
-	cd debian/build-openssl && autoreconf -i && dh_auto_configure
-	cd debian/build-gnutls && autoreconf -i && dh_auto_configure -- --without-openssl
+	cd debian/build-openssl && autoreconf -i && dh_auto_configure -- --without-examples
+	cd debian/build-gnutls && autoreconf -i && dh_auto_configure -- --without-openssl --without-examples
 
 override_dh_auto_build:
 	# execute dh_auto_build on both build flavours
@@ -38,8 +38,9 @@
 
 override_dh_auto_test:
 	# execute dh_auto_test on both build flavours
-	cd debian/build-openssl && dh_auto_test
-	cd debian/build-gnutls && dh_auto_test
+	# XXX temporarily disable tests due to: FAIL: jwt_rsa_pss
+	#cd debian/build-openssl && dh_auto_test
+	#cd debian/build-gnutls && dh_auto_test
 
 override_dh_auto_install:
 	echo dh_auto_install

## libjwt 1.17.2

=== tests/CMakeLists.txt ===
find_package (Check REQUIRED)

enable_testing ()

# Add the check target to behave like automake
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

set (TARGET_NAMES jwt_dump jwt_ec jwt_encode jwt_grant jwt_header jwt_new jwt_rsa jwt_validate)

if (UNIX)
	set (PLATFORM_LIBRARIES pthread)
endif ()

foreach (TARGET_NAME ${TARGET_NAMES})
	add_executable (${TARGET_NAME} ${TARGET_NAME}.c)
	target_include_directories (${TARGET_NAME} PRIVATE ${CHECK_INCLUDE_DIR})
	if (UNIX AND ENABLE_LTO)
		set_property(TARGET ${TARGET_NAME} PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
	endif ()
	target_compile_definitions (${TARGET_NAME} PRIVATE KEYDIR=\"${CMAKE_CURRENT_SOURCE_DIR}/keys\" _GNU_SOURCE)
	target_link_libraries (${TARGET_NAME} jwt ${CHECK_LIBRARIES} ${PLATFORM_LIBRARIES})
	add_test (${TARGET_NAME} ${TARGET_NAME})
endforeach ()

=== debian/changelog ===
libjwt (1.17.2-1) unstable; urgency=medium

  * New upstream release.
  * add gbp.conf, salsa-ci.yml and autopkgtest
  * add debian/clean (Closes: #1046215)
  * update symbols files

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 22 Nov 2024 18:58:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libjwt
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
+Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
 Build-Depends: debhelper-compat (= 13)
 	, pkg-config

=== debian/rules ===
--- 
+++ 
@@ -38,9 +38,8 @@
 
 override_dh_auto_test:
 	# execute dh_auto_test on both build flavours
-	# XXX temporarily disable tests due to: FAIL: jwt_rsa_pss
-	#cd debian/build-openssl && dh_auto_test
-	#cd debian/build-gnutls && dh_auto_test
+	cd debian/build-openssl && dh_auto_test
+	cd debian/build-gnutls && dh_auto_test
 
 override_dh_auto_install:
 	echo dh_auto_install

=== debian/tests/control ===
Tests: smoke
# don't depend on all binary packages
Depends: libjwt-dev, build-essential, pkg-config
Restrictions: allow-stderr
